<?php
/**
 * Diggin - Simplicity PHP Library
 * 
 * LICENSE
 *
 * This source file is subject to the new BSD license.
 * It is also available through the world-wide-web at this URL:
 * http://diggin.musicrider.com/LICENSE
 * 
 * @category   Diggin
 * @package    Diggin_Scraper
 * @copyright  2006-2008 sasezaki (http://diggin.musicrider.com)
 * @license    http://diggin.musicrider.com/LICENSE     New BSD License
 */

class Diggin_Scraper_Context
{
    /**
     * scraper's strategy 
     *
     * @var Diggin_Scraper_Strategy_Abstract $_strategy
     */
    private $_strategy;
    
    /**
     * construct
     * 
     * @param Diggin_Scraper_Strategy_Abstract $strategy
     */
    public function __construct(Diggin_Scraper_Strategy_Abstract $strategy)
    {
        $this->_strategy = $strategy;
    }

    /**
     * Read adapted resource vi strategy->readResource
     *
     * @return mixed 
     */
    public function read()
    {
        return $this->_strategy->readResource();
    }
}
